"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionsScannerService = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const permission_guard_1 = require("../guards/permission.guard");
let PermissionsScannerService = class PermissionsScannerService {
    constructor(_discoveryService, _reflector) {
        this._discoveryService = _discoveryService;
        this._reflector = _reflector;
        this._permissions = new Set();
    }
    get permissions() {
        return Array.from(this._permissions);
    }
    async onModuleInit() {
        const controllers = this._discoveryService.getControllers();
        for (const wrapper of controllers) {
            const { instance } = wrapper;
            if (!instance)
                continue;
            const prototype = Object.getPrototypeOf(instance);
            const methodNames = Object.getOwnPropertyNames(prototype);
            for (const methodName of methodNames) {
                const method = prototype[methodName];
                if (typeof method !== 'function')
                    continue;
                const args = this._reflector.get(permission_guard_1.ALLOW_PERMISSIONS_KEY, method);
                if (args && args.keywords) {
                    args.keywords.forEach((k) => this._permissions.add(k));
                }
            }
        }
    }
};
exports.PermissionsScannerService = PermissionsScannerService;
exports.PermissionsScannerService = PermissionsScannerService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.DiscoveryService, core_1.Reflector])
], PermissionsScannerService);
//# sourceMappingURL=permissions-scanner.service.js.map